# coding: utf-8

"""
    Identity Service API

    A list of identity, account and service management APIs.  # noqa: E501

    OpenAPI spec version: 1.6.5
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class ServiceRoleBindingWithGroups(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'id': 'str',
        'name': 'str',
        'membership_type': 'str',
        'expires_at': 'datetime',
        'resource': 'str',
        'groups': 'list[ExpandedTypedUserGroups]',
        'group_ids': 'list[str]'
    }

    attribute_map = {
        'id': 'id',
        'name': 'name',
        'membership_type': 'membershipType',
        'expires_at': 'expiresAt',
        'resource': 'resource',
        'groups': 'groups',
        'group_ids': 'groupIds'
    }

    def __init__(self, id=None, name=None, membership_type=None, expires_at=None, resource=None, groups=None, group_ids=None):  # noqa: E501
        """ServiceRoleBindingWithGroups - a model defined in Swagger"""  # noqa: E501
        self._id = None
        self._name = None
        self._membership_type = None
        self._expires_at = None
        self._resource = None
        self._groups = None
        self._group_ids = None
        self.discriminator = None
        if id is not None:
            self.id = id
        if name is not None:
            self.name = name
        if membership_type is not None:
            self.membership_type = membership_type
        if expires_at is not None:
            self.expires_at = expires_at
        if resource is not None:
            self.resource = resource
        if groups is not None:
            self.groups = groups
        if group_ids is not None:
            self.group_ids = group_ids

    @property
    def id(self):
        """Gets the id of this ServiceRoleBindingWithGroups.  # noqa: E501

        The identifier of the role.  # noqa: E501

        :return: The id of this ServiceRoleBindingWithGroups.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this ServiceRoleBindingWithGroups.

        The identifier of the role.  # noqa: E501

        :param id: The id of this ServiceRoleBindingWithGroups.  # noqa: E501
        :type: str
        """

        self._id = id

    @property
    def name(self):
        """Gets the name of this ServiceRoleBindingWithGroups.  # noqa: E501

        The name of the role.  # noqa: E501

        :return: The name of this ServiceRoleBindingWithGroups.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this ServiceRoleBindingWithGroups.

        The name of the role.  # noqa: E501

        :param name: The name of this ServiceRoleBindingWithGroups.  # noqa: E501
        :type: str
        """

        self._name = name

    @property
    def membership_type(self):
        """Gets the membership_type of this ServiceRoleBindingWithGroups.  # noqa: E501

        Membership type of the member in the organization. DIRECT: if the member roles were assigned directly. GROUP: if the member roles were assigned through enterprise group.  # noqa: E501

        :return: The membership_type of this ServiceRoleBindingWithGroups.  # noqa: E501
        :rtype: str
        """
        return self._membership_type

    @membership_type.setter
    def membership_type(self, membership_type):
        """Sets the membership_type of this ServiceRoleBindingWithGroups.

        Membership type of the member in the organization. DIRECT: if the member roles were assigned directly. GROUP: if the member roles were assigned through enterprise group.  # noqa: E501

        :param membership_type: The membership_type of this ServiceRoleBindingWithGroups.  # noqa: E501
        :type: str
        """
        allowed_values = ["DIRECT", "GROUP", "NESTED"]  # noqa: E501
        if membership_type not in allowed_values:
            raise ValueError(
                "Invalid value for `membership_type` ({0}), must be one of {1}"  # noqa: E501
                .format(membership_type, allowed_values)
            )

        self._membership_type = membership_type

    @property
    def expires_at(self):
        """Gets the expires_at of this ServiceRoleBindingWithGroups.  # noqa: E501

        The timestamp the role expires at (measured in number of seconds since 1/1/1970 UTC). The property is ignored by the identity service.  # noqa: E501

        :return: The expires_at of this ServiceRoleBindingWithGroups.  # noqa: E501
        :rtype: datetime
        """
        return self._expires_at

    @expires_at.setter
    def expires_at(self, expires_at):
        """Sets the expires_at of this ServiceRoleBindingWithGroups.

        The timestamp the role expires at (measured in number of seconds since 1/1/1970 UTC). The property is ignored by the identity service.  # noqa: E501

        :param expires_at: The expires_at of this ServiceRoleBindingWithGroups.  # noqa: E501
        :type: datetime
        """

        self._expires_at = expires_at

    @property
    def resource(self):
        """Gets the resource of this ServiceRoleBindingWithGroups.  # noqa: E501

        Identity does not support resource scoped permissions. The resource parameter is ignored.  # noqa: E501

        :return: The resource of this ServiceRoleBindingWithGroups.  # noqa: E501
        :rtype: str
        """
        return self._resource

    @resource.setter
    def resource(self, resource):
        """Sets the resource of this ServiceRoleBindingWithGroups.

        Identity does not support resource scoped permissions. The resource parameter is ignored.  # noqa: E501

        :param resource: The resource of this ServiceRoleBindingWithGroups.  # noqa: E501
        :type: str
        """

        self._resource = resource

    @property
    def groups(self):
        """Gets the groups of this ServiceRoleBindingWithGroups.  # noqa: E501

        List of group objects related to role.  # noqa: E501

        :return: The groups of this ServiceRoleBindingWithGroups.  # noqa: E501
        :rtype: list[ExpandedTypedUserGroups]
        """
        return self._groups

    @groups.setter
    def groups(self, groups):
        """Sets the groups of this ServiceRoleBindingWithGroups.

        List of group objects related to role.  # noqa: E501

        :param groups: The groups of this ServiceRoleBindingWithGroups.  # noqa: E501
        :type: list[ExpandedTypedUserGroups]
        """

        self._groups = groups

    @property
    def group_ids(self):
        """Gets the group_ids of this ServiceRoleBindingWithGroups.  # noqa: E501

        List of group unique identifiers related to role.  # noqa: E501

        :return: The group_ids of this ServiceRoleBindingWithGroups.  # noqa: E501
        :rtype: list[str]
        """
        return self._group_ids

    @group_ids.setter
    def group_ids(self, group_ids):
        """Sets the group_ids of this ServiceRoleBindingWithGroups.

        List of group unique identifiers related to role.  # noqa: E501

        :param group_ids: The group_ids of this ServiceRoleBindingWithGroups.  # noqa: E501
        :type: list[str]
        """

        self._group_ids = group_ids

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(ServiceRoleBindingWithGroups, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ServiceRoleBindingWithGroups):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
